# include       "trek.h"

/*
**  Ask a Klingon To Surrender
**
**      (Fat chance)
**
**      The Subspace Radio is needed to ask a Klingon if he will kindly
**      surrender.  A random Klingon from the ones in the quadrant is
**      chosen.
**
**      The Klingon is requested to surrender.  The probability of this
**      is a function of that Klingon's remaining power, our power,
**      etc.
*/

void capture()
{
	register int            i;
	register struct kling   *k;
	FLOAT                   x;
	extern struct kling     *selectklingon();

	/* check for not cloaked */
	if (Ship.cloaked)
	{
		printf("     \n");
		return;
	}
	if (damaged(SSRADIO)) {
		out(SSRADIO);
		return;
		}
	/* find out if there are any at all */
	if (Etc.nkling <= 0)
	{
		printf(":   , \n");
		return;
	}

	/* if there is more than one Klingon, find out which one */
	k = selectklingon();
	Move.free = 0;
	Move.time = 0.05;

	/* check out that Klingon */
	k->srndreq++;
	x = Param.klingpwr;
	x *= Ship.energy;
	x /= k->power * Etc.nkling;
	x *= Param.srndrprob;
	i = x;
#       ifdef xTRACE
	if (Trace)
		printf("Prob = %d (%.4f)\n", i, x);
#       endif
	if (i > ranf(100))
	{
		/* guess what, he surrendered!!! */
		printf("  %d,%d \n", k->x, k->y);
		i = ranf(Param.klingcrew);
		if ( i > 0 )
			printf("%d     \n", Param.klingcrew - i);
		if (i > Ship.brigfree)
			i = Ship.brigfree;
		Ship.brigfree -= i;
		printf("   %d \n", i);
		killk(k->x, k->y);
		return;
	}

	/* big surprise, he refuses to surrender */
	printf(" , ,   \n");
	return;
}


/*
**  SELECT A KLINGON
**
**      Cruddy, just takes one at random.  Should ask the captain.
*/

struct kling    *selectklingon()
{
	register int            i;

	if (Etc.nkling < 2)
		i = 0;
	else
		i = ranf(Etc.nkling);
	return (&Etc.klingon[i]);
}
